Как разрешить символические ссылки в сценарии оболочки

Учитывая абсолютный или относительный путь (в Unix-подобной системе), я хотел бы определить полный путь к цели после разрешения любых промежуточных символических ссылок. Бонусные баллы за одновременное разрешение нотации имени пользователя.

Если целью является каталог, можно было бы ввести chdir () в каталог, а затем вызвать getcwd (), но я действительно хочу сделать это из сценария оболочки, а не писать помощник C. К сожалению, оболочки имеют тенденцию пытаться скрыть существование символических ссылок от пользователя (это bash в OS X):

$ ls -ld foo bar
drwxr-xr-x   2 greg  greg  68 Aug 11 22:36 bar
lrwxr-xr-x   1 greg  greg   3 Aug 11 22:36 foo -> bar
$ cd foo
$ pwd
/Users/greg/tmp/foo
$

Я хочу, чтобы функция resolve () выполнялась из каталога tmp в приведенном выше примере, resolve ("foo") == "/ Users / greg / tmp / bar".

Ответов (19)

Решение

Согласно стандартам, pwd -P должен возвращать путь с разрешенными символическими ссылками.

Функция C char *getcwd(char *buf, size_t size) из unistd.h должна иметь такое же поведение.

getcwd pwd

Поскольку я сталкивался с этим много раз на протяжении многих лет, и на этот раз мне нужна была портативная версия на чистом bash, которую я мог бы использовать в OSX и Linux, я пошел дальше и написал одну:

Здесь живет живая версия:

https://github.com/keen99/shell-functions/tree/master/resolve_path

но ради ТАК, вот текущая версия (я считаю, что она хорошо протестирована ... но я открыт для отзывов!)

Может быть нетрудно заставить его работать для простой оболочки bourne (sh), но я не пробовал ... Мне слишком нравится $ FUNCNAME. :)

#!/bin/bash

resolve_path() {
    #I'm bash only, please!
    # usage:  resolve_path <a file or directory> 
    # follows symlinks and relative paths, returns a full real path
    #
    local owd="$PWD"
    #echo "$FUNCNAME for $1" >&2
    local opath="$1"
    local npath=""
    local obase=$(basename "$opath")
    local odir=$(dirname "$opath")
    if [[ -L "$opath" ]]
    then
    #it's a link.
    #file or directory, we want to cd into it's dir
        cd $odir
    #then extract where the link points.
        npath=$(readlink "$obase")
        #have to -L BEFORE we -f, because -f includes -L :(
        if [[ -L $npath ]]
         then
        #the link points to another symlink, so go follow that.
            resolve_path "$npath"
            #and finish out early, we're done.
            return $?
            #done
        elif [[ -f $npath ]]
        #the link points to a file.
         then
            #get the dir for the new file
            nbase=$(basename $npath)
            npath=$(dirname $npath)
            cd "$npath"
            ndir=$(pwd -P)
            retval=0
            #done
        elif [[ -d $npath ]]
         then
        #the link points to a directory.
            cd "$npath"
            ndir=$(pwd -P)
            retval=0
            #done
        else
            echo "$FUNCNAME: ERROR: unknown condition inside link!!" >&2
            echo "opath [[ $opath ]]" >&2
            echo "npath [[ $npath ]]" >&2
            return 1
        fi
    else
        if ! [[ -e "$opath" ]]
         then
            echo "$FUNCNAME: $opath: No such file or directory" >&2
            return 1
            #and break early
        elif [[ -d "$opath" ]]
         then 
            cd "$opath"
            ndir=$(pwd -P)
            retval=0
            #done
        elif [[ -f "$opath" ]]
         then
            cd $odir
            ndir=$(pwd -P)
            nbase=$(basename "$opath")
            retval=0
            #done
        else
            echo "$FUNCNAME: ERROR: unknown condition outside link!!" >&2
            echo "opath [[ $opath ]]" >&2
            return 1
        fi
    fi
    #now assemble our output
    echo -n "$ndir"
    if [[ "x${nbase:=}" != "x" ]]
     then
        echo "/$nbase"
    else 
        echo
    fi
    #now return to where we were
    cd "$owd"
    return $retval
}

вот классический пример, благодаря brew:

%% ls -l `which mvn`
lrwxr-xr-x  1 draistrick  502  29 Dec 17 10:50 /usr/local/bin/[email protected] -> ../Cellar/maven/3.2.3/bin/mvn

используйте эту функцию, и она вернет -real- путь:

%% cat test.sh
#!/bin/bash
. resolve_path.inc
echo
echo "relative symlinked path:"
which mvn
echo
echo "and the real path:"
resolve_path `which mvn`


%% test.sh

relative symlinked path:
/usr/local/bin/mvn

and the real path:
/usr/local/Cellar/maven/3.2.3/libexec/bin/mvn 
function realpath {
    local r=$1; local t=$(readlink $r)
    while [ $t ]; do
        r=$(cd $(dirname $r) && cd $(dirname $t) && pwd -P)/$(basename $t)
        t=$(readlink $r)
    done
    echo $r
}

#example usage
SCRIPT_PARENT_DIR=$(dirname $(realpath "$0"))/..

Собирая вместе некоторые из данных решений, зная, что ссылка для чтения доступна в большинстве систем, но требует разных аргументов, это хорошо работает для меня в OSX и Debian. Я не уверен насчет систем BSD. Возможно, условие должно заключаться [[ $OSTYPE != darwin* ]] в исключении -f только из OSX.

#!/bin/bash
MY_DIR=$( cd $(dirname $(readlink `[[ $OSTYPE == linux* ]] && echo "-f"` $0)) ; pwd -P)
echo "$MY_DIR"

Чтобы обойти несовместимость с Mac, я придумал

echo `php -r "echo realpath('foo');"`

Не отлично, но кросс-ОС

Попробуй это:

cd $(dirname $([ -L $0 ] && readlink -f $0 || echo $0))

Это преобразователь символических ссылок в Bash, который работает независимо от того, является ли ссылка каталогом или не каталогом:

function readlinks {(
  set -o errexit -o nounset
  declare n=0 limit=1024 link="$1"

  # If it's a directory, just skip all this.
  if cd "$link" 2>/dev/null
  then
    pwd -P
    return 0
  fi

  # Resolve until we are out of links (or recurse too deep).
  while [[ -L $link ]] && [[ $n -lt $limit ]]
  do
    cd "$(dirname -- "$link")"
    n=$((n + 1))
    link="$(readlink -- "${link##*/}")"
  done
  cd "$(dirname -- "$link")"

  if [[ $n -ge $limit ]]
  then
    echo "Recursion limit ($limit) exceeded." >&2
    return 2
  fi

  printf '%s/%s\n' "$(pwd -P)" "${link##*/}"
)}

Обратите внимание, что все cd и set прочее происходит в подоболочке.

Примечание: Я считаю , что это быть твердым, портативный, готовое решение, которое неизменно длительный по той же причине.

Ниже приведен полностью POSIX-совместимый скрипт / функция, которая, следовательно, является кроссплатформенной (работает и на macOS, которая readlink все еще не поддерживается -f с версии 10.12 (Sierra)) - она ​​использует только функции языка оболочки POSIX и только вызовы POSIX-совместимых утилит. .

Это переносимая реализация GNUreadlink -e (более строгая версия readlink -f ).

Вы можете запустить скрипт сsh или подключите функцию в bash, kshиzsh :

Например, внутри скрипта вы можете использовать его следующим образом, чтобы получить истинный исходный каталог запущенного скрипта с разрешенными символическими ссылками:

trueScriptDir=$(dirname -- "$(rreadlink "$0")")

rreadlink определение скрипта / функции:

Код был адаптирован с благодарностью из этого ответа .
Я также создал bash-А автономную версию утилиты здесь , которую можно установить с
npm install rreadlink -g, если у вас есть Node.js установлен.

#!/bin/sh

# SYNOPSIS
#   rreadlink <fileOrDirPath>
# DESCRIPTION
#   Resolves <fileOrDirPath> to its ultimate target, if it is a symlink, and
#   prints its canonical path. If it is not a symlink, its own canonical path
#   is printed.
#   A broken symlink causes an error that reports the non-existent target.
# LIMITATIONS
#   - Won't work with filenames with embedded newlines or filenames containing 
#     the string ' -> '.
# COMPATIBILITY
#   This is a fully POSIX-compliant implementation of what GNU readlink's
#    -e option does.
# EXAMPLE
#   In a shell script, use the following to get that script's true directory of origin:
#     trueScriptDir=$(dirname -- "$(rreadlink "$0")")
rreadlink() ( # Execute the function in a *subshell* to localize variables and the effect of `cd`.

  target=$1 fname= targetDir= CDPATH=

  # Try to make the execution environment as predictable as possible:
  # All commands below are invoked via `command`, so we must make sure that
  # `command` itself is not redefined as an alias or shell function.
  # (Note that command is too inconsistent across shells, so we don't use it.)
  # `command` is a *builtin* in bash, dash, ksh, zsh, and some platforms do not 
  # even have an external utility version of it (e.g, Ubuntu).
  # `command` bypasses aliases and shell functions and also finds builtins 
  # in bash, dash, and ksh. In zsh, option POSIX_BUILTINS must be turned on for
  # that to happen.
  { \unalias command; \unset -f command; } >/dev/null 2>&1
  [ -n "$ZSH_VERSION" ] && options[POSIX_BUILTINS]=on # make zsh find *builtins* with `command` too.

  while :; do # Resolve potential symlinks until the ultimate target is found.
      [ -L "$target" ] || [ -e "$target" ] || { command printf '%s\n' "ERROR: '$target' does not exist." >&2; return 1; }
      command cd "$(command dirname -- "$target")" # Change to target dir; necessary for correct resolution of target path.
      fname=$(command basename -- "$target") # Extract filename.
      [ "$fname" = '/' ] && fname='' # !! curiously, `basename /` returns '/'
      if [ -L "$fname" ]; then
        # Extract [next] target path, which may be defined
        # *relative* to the symlink's own directory.
        # Note: We parse `ls -l` output to find the symlink target
        #       which is the only POSIX-compliant, albeit somewhat fragile, way.
        target=$(command ls -l "$fname")
        target=${target#* -> }
        continue # Resolve [next] symlink target.
      fi
      break # Ultimate target reached.
  done
  targetDir=$(command pwd -P) # Get canonical dir. path
  # Output the ultimate target's canonical path.
  # Note that we manually resolve paths ending in /. and /.. to make sure we have a normalized path.
  if [ "$fname" = '.' ]; then
    command printf '%s\n' "${targetDir%/}"
  elif  [ "$fname" = '..' ]; then
    # Caveat: something like /var/.. will resolve to /private (assuming /[email protected] -> /private/var), i.e. the '..' is applied
    # AFTER canonicalization.
    command printf '%s\n' "$(command dirname -- "${targetDir}")"
  else
    command printf '%s\n' "${targetDir%/}/$fname"
  fi
)

rreadlink "[email protected]"

Касательно безопасности:

jarno в отношении функции, гарантирующей, что встроенная функция command не затеняется псевдонимом или функцией оболочки с тем же именем, спрашивает в комментарии:

Что, если unaliasили unsetи [установлены как псевдонимы или функции оболочки?

Мотивация, лежащая в основе rreadlink обеспечения того, что это command имеет свое первоначальное значение, состоит в том, чтобы использовать его для обхода (мягких) удобных псевдонимов и функций, часто используемых для затенения стандартных команд в интерактивных оболочках, таких как переопределение ls для включения избранных параметров.

Я думаю , что можно с уверенностью сказать , что если вы имеете дело с ненадежной, злонамеренного среде, заботясь о том unalias или unset - или, если на то пошло, while, do ... - пересматриваются не является проблемой.

Есть кое- что, на что функция должна полагаться, чтобы иметь свое первоначальное значение и поведение - нет никакого способа обойти это.
Оболочки, подобные POSIX, допускают переопределение встроенных функций и даже ключевых слов языка, по сути, представляют собой угрозу безопасности (а писать параноидальный код в целом сложно).

Чтобы конкретно решить ваши проблемы:

Функция полагается unalias и unset имеет свое первоначальное значение. Переопределить их как функции оболочки таким образом, чтобы изменить их поведение, было бы проблемой; переопределение как псевдонима не обязательно вызывает беспокойство, потому что цитирование (части) имени команды (например, \unalias ) обходит псевдонимы.

Однако, ссылаясь на это не вариант для оболочки ключевых слов ( while, for, if, do, ...) , и в то время как ключевые слова оболочки делают имеют преимущество над оболочками функций , в bash и zsh псевдонимами имеют наивысший приоритет, поэтому для защиты от оболочечных ключевого слова переопределениях вы должны работать unalias с их имена (хотя в неинтерактивных bash оболочках (например, скриптах) псевдонимы не раскрываются по умолчанию - только если они shopt -s expand_aliases явно вызываются первыми).

Чтобы гарантировать, что unalias - как встроенный - имеет свое первоначальное значение, вы должны \unset сначала использовать его, что требует, чтобы оно unset имело исходное значение:

unset - это встроенная оболочка , поэтому, чтобы гарантировать, что она вызывается как таковая, вам нужно убедиться, что она сама не переопределяется как функция . Хотя вы можете обойти форму псевдонима с помощью цитирования, вы не можете обойти форму функции оболочки - catch 22.

Таким образом, насколько unset я могу судить , если вы не можете полагаться на его первоначальное значение, не существует гарантированного способа защиты от всех злонамеренных переопределений.

Здесь я представляю то, что я считаю кроссплатформенным (по крайней мере, для Linux и macOS), на ответ, который хорошо работает для меня в настоящее время.

crosspath()
{
    local ref="$1"
    if [ -x "$(which realpath)" ]; then
        path="$(realpath "$ref")"
    else
        path="$(readlink -f "$ref" 2> /dev/null)"
        if [ $? -gt 0 ]; then
            if [ -x "$(which readlink)" ]; then
                if [ ! -z "$(readlink "$ref")" ]; then
                    ref="$(readlink "$ref")"
                fi
            else
                echo "realpath and readlink not available. The following may not be the final path." 1>&2
            fi
            if [ -d "$ref" ]; then
                path="$(cd "$ref"; pwd -P)"
            else
                path="$(cd $(dirname "$ref"); pwd -P)/$(basename "$ref")"
            fi
        fi
    fi
    echo "$path"
}

Вот решение для macOS (только?). Возможно, лучше подходит для исходного вопроса.

mac_realpath()
{
    local ref="$1"
    if [[ ! -z "$(readlink "$ref")" ]]; then
        ref="$(readlink "$1")"
    fi
    if [[ -d "$ref" ]]; then
        echo "$(cd "$ref"; pwd -P)"
    else
        echo "$(cd $(dirname "$ref"); pwd -P)/$(basename "$ref")"
    fi
}

В случае, если невозможно использовать pwd (например, вызов скриптов из другого места), используйте реальный путь (с именем dirname или без него):

$(dirname $(realpath $PATH_TO_BE_RESOLVED))

Работает как при вызове через (несколько) символических ссылок, так и при прямом вызове скрипта - из любого места.

Ваш путь - это каталог, или это может быть файл? Если это каталог, это просто:

(cd "$DIR"; pwd -P)

Однако, если это может быть файл, это не сработает:

DIR=$(cd $(dirname "$FILE"); pwd -P); echo "${DIR}/$(readlink "$FILE")"

потому что символическая ссылка может преобразоваться в относительный или полный путь.

В сценариях мне нужно найти реальный путь, чтобы я мог ссылаться на конфигурацию или другие сценарии, установленные вместе с ним, я использую это:

SOURCE="${BASH_SOURCE[0]}"
while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
  DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
  SOURCE="$(readlink "$SOURCE")"
  [[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
done

Вы можете установить SOURCE любой путь к файлу. По сути, пока путь является символической ссылкой, он разрешает эту символическую ссылку. Уловка находится в последней строке цикла. Если разрешенная символическая ссылка является абсолютной, она будет использоваться как SOURCE . Однако, если он относительный, он добавит вместо него метку DIR, которая была преобразована в реальное местоположение с помощью простого трюка, который я впервые описал.

Обычным сценариям оболочки часто приходится находить свой «домашний» каталог, даже если они вызываются как символическая ссылка. Таким образом, скрипт должен найти их «реальную» позицию всего за $ 0.

cat `mvn`

в моей системе печатает сценарий, содержащий следующее, что должно быть хорошим намеком на то, что вам нужно.

if [ -z "$M2_HOME" ] ; then
  ## resolve links - $0 may be a link to maven's home
  PRG="$0"

  # need this for relative symlinks
  while [ -h "$PRG" ] ; do
    ls=`ls -ld "$PRG"`
    link=`expr "$ls" : '.*-> \(.*\)$'`
    if expr "$link" : '/.*' > /dev/null; then
      PRG="$link"
    else
      PRG="`dirname "$PRG"`/$link"
    fi
  done

  saveddir=`pwd`

  M2_HOME=`dirname "$PRG"`/..

  # make it fully qualified
  M2_HOME=`cd "$M2_HOME" && pwd`
readlink -f "$path"

Примечание редактора: вышеперечисленное работает с GNU readlink и FreeBSD / PC-BSD / OpenBSD readlink , но не с OS X с 10.11.
GNU readlink предлагает дополнительные связанные опции, например, -mдля разрешения символической ссылки вне зависимости от того, существует ли конечная цель.

Обратите внимание, что, начиная с GNU coreutils 8.15 (2012-01-06), доступна программа realpath, которая менее тупая и более гибкая, чем приведенная выше. Он также совместим с одноименной утилитой FreeBSD. Он также включает функцию создания относительного пути между двумя файлами.

realpath $path

[Добавление администратора ниже из комментария Halloleo - danorton]

Для Mac OS X (по крайней мере, до 10.11.x) используйте readlink без -f опции:

readlink $path

Примечание редактора: это не приведет к рекурсивному разрешению символических ссылок и, следовательно, не будет сообщать конечную цель; например, если дана символическая ссылка, aкоторая указывает на b, которая, в свою очередь, указывает на c, это будет только отчет b(и не гарантирует, что он будет выведен как абсолютный путь ).
Используйте следующую perlкоманду в OS X, чтобы заполнить пробел отсутствующей readlink -fфункциональности:
perl -MCwd -le 'print Cwd::abs_path(shift)' "$path"

Один из моих любимых - realpath foo

realpath - вернуть канонизированный абсолютный путь

realpath расширяет все символические ссылки и разрешает ссылки на '/./', '/../' и дополнительные символы '/' в строке с завершающим нулем, названной путем и
       сохраняет канонизированный абсолютный путь в буфере размера PATH_MAX, названном resolved_path. Полученный путь не будет иметь символической ссылки, '/./' или
       '/../' компоненты.

Кажется, что "pwd -P" работает, если вам просто нужен каталог, но если по какой-то причине вам нужно имя фактического исполняемого файла, я не думаю, что это помогает. Вот мое решение:

#!/bin/bash

# get the absolute path of the executable
SELF_PATH=$(cd -P -- "$(dirname -- "$0")" && pwd -P) && SELF_PATH=$SELF_PATH/$(basename -- "$0")

# resolve symlinks
while [[ -h $SELF_PATH ]]; do
    # 1) cd to directory of the symlink
    # 2) cd to the directory of where the symlink points
    # 3) get the pwd
    # 4) append the basename
    DIR=$(dirname -- "$SELF_PATH")
    SYM=$(readlink "$SELF_PATH")
    SELF_PATH=$(cd "$DIR" && cd "$(dirname -- "$SYM")" && pwd)/$(basename -- "$SYM")
done

Другой путь:

# Gets the real path of a link, following all links
myreadlink() { [ ! -h "$1" ] && echo "$1" || (local link="$(expr "$(command ls -ld -- "$1")" : '.*-> \(.*\)$')"; cd $(dirname $1); myreadlink "$link" | sed "s|^\([^/].*\)\$|$(dirname $1)/\1|"); }

# Returns the absolute path to a command, maybe in $PATH (which) or not. If not found, returns the same
whereis() { echo $1 | sed "s|^\([^/].*/.*\)|$(pwd)/\1|;s|^\([^/]*\)$|$(which -- $1)|;s|^$|$1|"; } 

# Returns the realpath of a called command.
whereis_realpath() { local SCRIPT_PATH=$(whereis $1); myreadlink ${SCRIPT_PATH} | sed "s|^\([^/].*\)\$|$(dirname ${SCRIPT_PATH})/\1|"; } 
readlink -e [filepath]

похоже, именно то, что вы просите - он принимает произвольный путь, разрешает все символические ссылки и возвращает «реальный» путь - и это «стандартный * nix», который, вероятно, уже есть во всех системах

Вот как можно получить фактический путь к файлу в MacOS / Unix с помощью встроенного скрипта Perl:

FILE=$(perl -e "use Cwd qw(abs_path); print abs_path('$0')")

Аналогичным образом, чтобы получить каталог файла с символической ссылкой:

DIR=$(perl -e "use Cwd qw(abs_path); use File::Basename; print dirname(abs_path('$0'))")

Мой ответ здесь Bash: как получить реальный путь символической ссылки?

но вкратце очень удобно в скриптах:

script_home=$( dirname $(realpath "$0") )
echo Original script home: $script_home

Это часть GNU coreutils, подходящая для использования в системах Linux.

Чтобы все протестировать, мы помещаем символическую ссылку в / home / test2 /, исправляем некоторые дополнительные вещи и запускаем / вызываем ее из корневого каталога:

/$ /home/test2/symlink
/home/test
Original script home: /home/test

Где

Original script is: /home/test/realscript.sh
Called script is: /home/test2/symlink